
/*
* 重新载入对话框
* */
function reloadDialog() {
    location.reload();
}

/*
 * 初始化图层
 * */
function initLayers() {
    $('#olsortable').empty();
    addLayerFromRuby("Layer0", "0", undefined, false)
}

//The following is from John "driven" Boundy
/* Creates a uppercase hex number with at least length digits from a given number */
function fixedHex(number, length) {
    var str = number.toString(16).toUpperCase();
    while (str.length < length)
        str = "0" + str;
    return str;
}

/* Creates a unicode literal based on the string. nts: UTF-8 is an encoding - Unicode is a character set*/
function unicodeLiteral(str) {
    var i;
    var result = "";
    for (i = 0; i < str.length; ++i) {
        /* You should probably replace this by an isASCII test */
        if (str.charCodeAt(i) > 126 || str.charCodeAt(i) < 32)
            result += "\\\\" + "u" + fixedHex(str.charCodeAt(i), 4);
        else
            result += str[i];
    }
    return result;
}

//-------------

function makeUnselectable(node) {
    if (node.nodeType == 1) {
        node.setAttribute("unselectable", "on");
    }
    var child = node.firstChild;
    while (child) {
        makeUnselectable(child);
        child = child.nextSibling;
    }
    $('.inputNameInput').removeAttr('unselectable');
    $('body').removeAttr('unselectable');
    $('html').removeAttr('unselectable');
    $('ol').removeAttr('unselectable');
    $('input').removeAttr('unselectable');
    $('button').removeAttr('unselectable');
    $('label').removeAttr('unselectable');
    $('#confirmDelete').removeAttr('unselectable');
    $('#wrapper').removeAttr('unselectable');
}

//-------------

/*
* 刷新显示模型的图层
* */
function refreshModelLayers() {
    RBC.GUI.DialogProxy.callback({
        name: 'refreshModelLayers',
        data: true,
        success:function () {

        }
    });
}

//-------------

/*
* 刷新激活当前图层
* */
function refreshActiveLayer() {
    RBC.GUI.DialogProxy.callback({
        name: 'refreshActiveLayer',
        data: true,
        success: function (layerID) {
            setActiveLayerFromRuby(layerID)
        }
    });
}

//-------------

/*
* 刷新展开组
* */
function refreshCollapsedGroups() {
    RBC.GUI.DialogProxy.callback({
        name: 'refreshCollapsedGroups',
        data: true,
        success:function () {

        }
    });
}

//-------------

/*
* 设置激活图层在UI上。
* */
function setActiveLayerFromRuby(layerID) {
    $(".enabled").removeClass("enabled").addClass("disabled");
    $("#layer_" + layerID).children("div").children(".active").removeClass("disabled").addClass("enabled");
}

//-------------

/*
* 设置激活图层在SU。
* */
function setActiveLayerFromJS(layerID) {
    layerID = layerID.replace('layer_', '');
    RBC.GUI.DialogProxy.callback({
        name: 'setActiveLayerFromJS',
        data: layerID,
        success:function () {

        }
    });
}

//-------------

/*
*
* */
function addLayerFromRuby(layerName, layerID, parentID, serialize, lock) {
    if ($("#layer_" + layerID).length == 0) { // layer doesn't exists yet in the DOM
        var locked = '';
        if (lock == "true") {
            locked = ' locked';
        }
        var layerStr = '<li id="layer_' + layerID + '" class="layer mjs-nestedSortable-no-nesting mjs-nestedSortable-leaf" unselectable="on"><div class="lidiv" unselectable="on"><div class="handle" unselectable="on"></div><div class="visibility visible" unselectable="on"></div><div class="active disabled" unselectable="on"></div><div class="lock2' + locked + '" unselectable="on"></div><span class="inputName" ><input class="inputNameInput" type="text" value="' + layerName + '" /></span><span class="layerName"><span class="layerNameText" unselectable="on">' + layerName + '</span></span></div></li>';
        if (parentID && parentID != "null") { //ID parentID is set, find it and append to it
            parentID = '#group_' + parentID;
            $(parentID).children("ol").append(layerStr);
        } else { //else, append normally
            if ($('.ui-selected').length > 0) { //if something selected
                selectedItem = $('.ui-selected').last().parent()
                if (selectedItem.hasClass('group')) { //if append to group
                    selectedItem.children('ol').append(layerStr);
                } else {
                    selectedItem.after(layerStr);
                }
            } else {
                $('.sortable').append(layerStr);
            }
        }
    }
}

//-------------

function guid() {
    return 'xxxxxxxxxxxxxxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
        return v.toString(10);
    });
}

function uniqueGroupName() {
    //Check if Group nb exists
    var groupNb = 1;
    while (true) {
        var groupName = RBC.Language.tr('Group')+' ' + groupNb;
        if ($("span").filter(function () {
                return ($(this).text() === groupName)
            }).length) {
            groupNb++;
        } else {
            break;
        }
    }
    return groupName;
}

function addGroup(groupName, groupID, parentID, appendToSelected) {
    if (!groupID) {
        var groupName = uniqueGroupName();
        groupID = guid();
    }
    var groupStr = '<li id="group_' + groupID + '" class="group mjs-nestedSortable-branch mjs-nestedSortable-expanded"><div class="lidiv"><div class="handle"></div><div class="visibility visible"></div><span class="disclose"></span><span class="inputName" ><input class="inputNameInput" type="text" /></span><span class="layerName"><span class="layerNameText">' + groupName + '</span></span></div><ol></ol></li>';
    if (parentID && parentID != "null") { //ID parentID is set, find it and append to it
        parentID = '#group_' + parentID;
        $(parentID).children("ol").append(groupStr);
    } else { //else, append normallyf
        if ($('.ui-selected').length > 0 && appendToSelected != false) { //if something selected
            if ($('.ui-selected').last().parent().hasClass('group')) { //if append to group
                $('.ui-selected').last().parent().children('ol').append(groupStr);
            } else {
                $('.ui-selected').last().parent().after(groupStr);
            }
        } else {
            $('.sortable').append(groupStr);
        }
    }
    return groupID;
}

function groupLayers() { // Group selected layers
    if ($(".ui-selected").length) {
        var groupName = uniqueGroupName();
        var id = guid();
        addGroup(groupName, id, undefined, false);
        var groupID = "#group_" + id;
        var groupOl = $(groupID).children("ol");

        firstSelected = $(".ui-selected:first").parent();

        $(groupID).insertAfter(firstSelected);

        $('.ui-selected').each(function () {
            var item = $(this).parent();
            if (!item.parent().parent().children(".lidiv").is(".ui-selected") && !item.is("#layer_0")) { // If not nested in selected
                item.appendTo(groupOl);
            }
        });
        $('.ui-selected').each(function () {
            $(this).removeClass("ui-selected"); // Deselect all
        });
        $(groupID).children(".lidiv").addClass("ui-selected"); // Select new group
        RBC.GUI.DialogProxy.callback({
            name: 'groupLayers',
            data:  {
                id:id,
                name:groupName,
                serialized:serialize_cache()
            },
            success:function () {

            }
        });
    }
}

function unGroupLayers() { // Ungroup selected group
    if ($(".ui-selected").length) {
        $(".ui-selected").each(function () {
            var item = $(this).parent();
            if (isGroup(item) && !item.parent().parent().children(".lidiv").is(".ui-selected")) { // If group && not nested in selected
                item.addClass("delete");
            }
        });
        $(".ui-selected").each(function () {
            var item = $(this).parent();
            if (isGroup(item)) {
                if (item.hasClass("delete")) {
                    item.children("ol").children("li").insertBefore(item);
                    item.empty().remove();
                }
                RBC.GUI.DialogProxy.callback({
                    name: 'unGroupLayers',
                    data: serialize_cache(),
                    success: function (data) {
                        //
                    }
                });
            }
        });
    }
}

//-------------

function renameLayerFromJS(layerID, newLayerName) {
    RBC.GUI.DialogProxy.callback('renameLayerFromJS', {
        "id": layerID,
        "name": newLayerName
    });
}

function renameLayerFromRuby(layerID, layerName) {
    $("#layer_" + layerID).children("div").children(".layerName").children(".layerNameText").text(layerName);
}

function renameGroup(groupID, newGroupName) {
    groupID = groupID.replace('group_', '');
    RBC.GUI.DialogProxy.callback({
        name: 'renameGroup',
        data: {
            "id": groupID,
            "name": newGroupName
        },
        success:function () {

        }
    });
}

function collapseFromRuby(groupID) {
    $("#group_" + groupID).removeClass('mjs-nestedSortable-expanded').addClass('mjs-nestedSortable-collapsed');
}

//-------------

function setColorFromRuby(layerID, color) {
    $("#layer_" + layerID).find(".handle, .handle0").css("background-color", color);
}

function toggleColorsButton(check) {
    if (check == true) {
        $("#colors").parent().addClass('footerElementChecked');
    } else {
        $("#colors").parent().removeClass('footerElementChecked');
    }
}

//-------------

function lock() {
    var unlocked = false;
    $('.ui-selected').each(function () { // Check if at least one layer is unlocked
        if ($(this).parent().hasClass("layer")) { // If layer
            if (!$(this).parent().find('.lock2').hasClass('locked')) {
                unlocked = true;
                return false;
            }
        }
    });
    var ids = {};
    $('.ui-selected').each(function () { // Lock or unlock layers
        if ($(this).parent().hasClass("layer")) { // If layer
            layerID = $(this).closest('div').parent().attr('id');
            layerID = layerID.replace('layer_', '');
            if(layerID=='0'){
                // pass
            }else{
                if (unlocked == false) {
                    $(this).parent().find('.lock2').removeClass('locked');
                    ids[layerID]= false;
                } else {
                    $(this).parent().find('.lock2').addClass('locked');
                    ids[layerID]= true;
                }
            }

        }
    });
    RBC.GUI.DialogProxy.callback({
        name: 'lockOptions',
        data: ids,
        success:function () {

        }
    });
    unlocked = false;
}

//------------

function trash(deleteGeom, currentLayer) {
    var layer0 = false;
    $('.ui-selected').each(function () {
        if ($(this).parent().is("#layer_0")) {
            layer0 = true;
        }
    });
    if (layer0) {
        alert(RBC.Language.tr("You can't delete layer0"));
        return;
    }
    var locked = false;
    $('.ui-selected').each(function () { // Check if at least one layer is locked
        if ($(this).parent().find('.lock2').hasClass('locked')) {
            locked = true;
            return false;
        }
    });
    if (locked == false) {
        $('#id0').children('.lidiv').removeClass('ui-selected'); // Prevent Layer0 delete
        layerContent = false; //Reset
        $('.ui-selected').each(function () {
            if ($(this).parent().hasClass("group")) { // If Group
                $(this).parent().find('.lidiv').addClass('ui-selected'); // Select all nested layers and groups
            }
        });
        if (deleteGeom == true) {
            if (confirm(RBC.Language.tr("Are you sure you want to delete this layer(s) and all of its content ?"))) {
                trash2(true);
            }
        } else if (currentLayer == true) {
            trash2(false, true);
        } else {
            trash2(false);
        }
    } else {
        alert(RBC.Language.tr("You can't delete locked layers."));
    }
}

function trash2(deleteGeom, currentLayer) {
    $('.ui-selected').each(function () { // First, deal with layers
        if ($(this).parent().hasClass("layer")) { // If layer
            layerID = $(this).parent().attr('id');
            layerID = layerID.replace('layer_', '');
            deleteLayerFromJS(layerID, deleteGeom, currentLayer);
            deleteLayerFromRuby(layerID)
        }
    });
    $('.ui-selected').each(function () { // Then, delete groups
        if ($(this).parent().hasClass("group")) { // If group
            $(this).parent().empty().remove();
        }
    });
    RBC.GUI.DialogProxy.callback({
        name: 'storeSerialize',
        data: true
    });
}

//-------------

function deleteLayerFromJS(layerID, deleteGeom, currentLayer) {
    if (deleteGeom == true) {
        RBC.GUI.DialogProxy.callback({
            name: 'deleteLayer&GeomFromJS',
            data: [layerID]
        });
    } else if (currentLayer == true) {
        RBC.GUI.DialogProxy.callback({
            name: 'deleteLayerToCurrentFromJS',
            data: [layerID]
        });
    } else {
        RBC.GUI.DialogProxy.callback({
            name: 'deleteLayerFromJS',
            data: [layerID]
        });
    }
}

function deleteLayerFromRuby(layerID) {
    $("#layer_" + layerID).empty().remove();
}

function mergeLayers() {
    $('.ui-selected').each(function () { // Select all nested layers and groups
        var item = $(this).parent();
        if (isGroup(item)) {
            item.find('.lidiv').addClass('ui-selected');
        }
    });
    var layerIDs = '';
    var i = 1;
    $('.ui-selected').each(function () { // Create a string with all the ID of the layers being merged
        var item = $(this).parent();
        if (i == 1 && isGroup(item)) {
            layerIDs += item.children(".lidiv").children(".layerName").children(".layerNameText").text();
            layerIDs += ','
        } else if (!isGroup(item)) {
            layerIDs += item.attr('id').replace('layer_', '');
            layerIDs += ','
        }
        i++;
    });
    $('.ui-selected').each(function () { // Remove all groups
        var item = $(this).parent();
        if (isGroup(item)) {
            item.empty().remove();
        }
    });
    RBC.GUI.DialogProxy.callback({
        name: 'mergeLayers',
        data: layerIDs,
        success: function (data) {
            storeSerialize();
        }
    });
}

//-------------

function showLayerFromJS(layerID) {
    RBC.GUI.DialogProxy.callback({
        name: 'showLayerFromJS',
        data: layerID,
        success:function () {

        }
    });
}

function hideLayerFromJS(layerID, grouped) {
    RBC.GUI.DialogProxy.callback({
        name: 'hideLayerFromJS',
        data: layerID,
        success:function () {

        }
    });
}

function setLayerVisible(layerID, visible) {
    if (visible) {
        unHide($("#layer_" + layerID), undefined, true);
        $("#layer_" + layerID).children("div").children(".visibility").removeClass("hidden").addClass("visible");
    } else {
        hide($("#layer_" + layerID), undefined, true);
        $("#layer_" + layerID).children("div").children(".visibility").removeClass("visible").addClass("hidden");
    }
}

function showLayerFromRuby(layerID) {
    unHide($("#layer_" + layerID), undefined, true);
    $("#layer_" + layerID).children("div").children(".visibility").removeClass("hidden").addClass("visible");
}


function hideLayerFromRuby(layerID) {
    hide($("#layer_" + layerID), undefined, true);
    $("#layer_" + layerID).children("div").children(".visibility").removeClass("visible").addClass("hidden");
}


function hideByGroupFromRuby(layerID) {
    $("#layer_" + layerID).children("div").children(".visibility").removeClass("visible").removeClass("hidden").addClass("hiddenByGroup");
}


function hideGroupFromRuby(groupID, byGroup) {
    if (!byGroup) {
        $("#group_" + groupID).addClass("hiddenGroup").children("div").children(".visibility").removeClass("visible").addClass("hidden");
    }
    else {
        $("#group_" + groupID).addClass("hiddenGroup").children("div").children(".visibility").removeClass("visible").addClass("hiddenByGroup");
    }
}

function purgeGroups() {
    $(".group").each(function () {
        if ($(this).find(".layer").length == 0) {
            $(this).remove();
        }
    });
    RBC.GUI.DialogProxy.callback({
        name: 'purgeGroups',
        data: serialize_cache()
    });
}

//-------------

function isGroup(item) {
    return item.hasClass("group");
}

function hide(item, byGroup, ruby, warning) {
    if (item.find(".enabled").length) { // If active layer
        if (warning != false) {
            alert(RBC.Language.tr('You cannot hide the current layer.'));
        }
    } else {
        visibility = item.children("div").children(".visibility");
        visibility.removeClass("visible");
        if (byGroup) {
            visibility.addClass("hiddenByGroup");
        } else {
            visibility.addClass("hidden");
        }
        if (isGroup(item)) { //is group
            var groupID = item.attr('id').replace('group_', '');
            if (!byGroup) { //mark group as hidden directly on its highest element
                item.addClass("hiddenGroup");
                RBC.GUI.DialogProxy.callback({
                    name: 'hideGroup',
                    data: true
                });
            } else {
                RBC.GUI.DialogProxy.callback({
                    name: 'hideGroupByGroup',
                    data: groupID
                });
            }

            item.children("ol").children(".group").each(function (i) { // Hide visible groups
                if ($(this).children(".lidiv").children(".visibility").hasClass("visible")) {
                    hide($(this), true);
                }
            });
            item.children("ol").children(".layer").each(function (i) { // Hide visible layers
                if ($(this).children(".lidiv").children(".visibility").hasClass("visible")) {
                    hide($(this), true);
                }
            });
        } else { //is layer
            if (!ruby) {
                layerID = item.attr('id').replace('layer_', '');
                hideLayerFromJS(layerID);
                if (byGroup) {
                    RBC.GUI.DialogProxy.callback({
                        name: 'hideByGroup',
                        data: layerID
                    });
                }
            }
        }
    }
}

function unHide(item, clicked, ruby) {
    visibility = item.children("div").children(".visibility");
    if (clicked) {
        visibility.addClass("hiddenByGroup");
    }
    if (item.parents(".hiddenGroup").length > 0) { // If nested in hidden group
        stop = false;
        item.parents(".hiddenGroup").each(function () {
            if (!stop) {
                closestHiddenGroup = $(this);
            }
            stop = true
        });
        unHide(closestHiddenGroup, true);
    } else {
        visibility.removeClass("hiddenByGroup").removeClass("hidden").addClass("visible");
        if (isGroup(item)) { //is group
            item.removeClass("hiddenGroup");
            groupID = item.attr('id').replace('group_', '');
            RBC.GUI.DialogProxy.callback({
                name: 'unHideGroup',
                data: groupID
            });
            item.children("ol").children(".group").each(function (i) { // unHide hiddenByGroup groups
                if ($(this).children(".lidiv").children(".visibility").hasClass("hiddenByGroup")) {
                    unHide($(this), true);
                }
            });
            item.children("ol").children(".layer").each(function (i) { // unHide hiddenByGroup layers
                if ($(this).children(".lidiv").children(".visibility").hasClass("hiddenByGroup")) {
                    unHide($(this), true);
                }
            });
        } else { //is layer
            if (!ruby) {
                layerID = item.attr('id').replace('layer_', '');
                showLayerFromJS(layerID);
            }
        }
    }
}

//-------------

/*
* 排序结构数据
* */
function serialize_cache() {
    return $('ol.sortable').nestedSortable('serialize');
}

/*
 * 保存缓存
 * */
function storeSerialize() {
    RBC.GUI.DialogProxy.callback({
        name: 'storeSerialize',
        data: $('ol.sortable').nestedSortable('serialize')
    });
}

//------高亮图层-------

function hightlightLayer(layerID) {
    layerID = "#layer_" + layerID;
    $(layerID).children(".lidiv").addClass("ui-selected");
}

function hightlightLayerFormRuby(layerID) {
    layerID = "#layer_" + layerID;
    $(layerID).children(".lidiv").addClass("ui-selected");
}

function unHightlightLayer() {
    $('.ui-selected').removeClass('ui-selected');
}

/*
* ***************
* 右键菜单
* ***************
* */

/*
* 右键菜单:选择高亮图层的物体
* */
function selectLayersContent() {
    if ($('.ui-selected').length == 0) {
        alert(RBC.Language.tr("Please select a layer"));
    } else {
        var ids = [];
        $('.ui-selected').each(function () {
            layerID = $(this).parent().attr('id').replace('layer_', '');
            ids.push(layerID)
        });
        RBC.GUI.DialogProxy.callback({
            name: 'selectFromLayer',
            data: ids
        });
    }
}

/*
* 右键菜单:孤立显示
* */
function onlyVisible() {
    if ($('.ui-selected').length == 0) {
        alert(RBC.Language.tr("Please select a layer"));
    } else {
        var ids = [];
        $('.ui-selected').each(function () {
            layerID = $(this).parent().attr('id').replace('layer_', '');
            ids.push(layerID);
        });
        RBC.GUI.DialogProxy.callback({
            name: 'onlyVisible',
            data: ids
        });
    }
}

/*
* 切换图层可见性
* */
function toggleVisible() {
    var ids = [];
    $('.ui-selected').each(function () {
        layerID = $(this).parent().attr('id').replace('layer_', '');
        ids.push(layerID);
    });
    RBC.GUI.DialogProxy.callback({
        name: 'toggleVisible',
        data: ids
    });
}
